<?php
/**
 *	POWER + SITE  -  Core -> [FONCTIONS] PHP Plus
 *	Auteur : Power + Technologie <http://power-plus-technologie.fr>
 *	Licence : Creative Commons BY-NC
 *
 *	Fonctions PHP supplémentaire utilisable dans tous le CMS
 */


/**
 *	Permet de trier un tableau suivant la valeur d'une clé définit.
 *	@param $array array Tableau à trier
 *	@param $key string Clé du tableau
 *	@param $ordre string asc/dsc trie ascendant ou descendant
 *	@return array Tableau trié
 */
function sortByKey($array, $key, $ordre = 'dsc') {
	if(is_array($array)) {
		if($ordre == 'dsc') {
			usort($array, create_function('$a, $b', '$a = $a["'.$key.'"]; $b = $b["'.$key.'"]; if ($a == $b) return 0; return ($a > $b) ? 1 : -1;'));
		}
		elseif($ordre == 'asc') {
			usort($array, create_function('$a, $b', '$a = $a["'.$key.'"]; $b = $b["'.$key.'"]; if ($a == $b) return 0; return ($a < $b) ? 1 : -1;'));
		}
		return $array;
	}
	else
		return false;
}


/**
 *
 */
function byteConvert(&$bytes) {
	$b = (int)$bytes; 
	$s = array('', 'K', 'M', 'G', 'T'); 
	if($b < 0){ 
	    return "0 ".$s[0]; 
	} 
	$con = 1024; 
	$e = (int)(log($b,$con)); 
	return number_format($b / pow($con, $e), 2, ',', '.') .' '. $s[$e]; 
}


/**
 *
 */
function array_remove_value() {
	$args = func_get_args();
	return array_diff($args[0],array_slice($args,1));
}


/**
 *	Supprimer les accents en caractère normale et supprime les majuscules
 */
function normaliser($str, $default = '-') {
	$str = strtolower(utf8_decode($str));
	$car_mauv = array('é', 'è', 'Ãª', 'Ã«',
					  'Ã¢', 'à', 'Ã¤', 'à', '@',
					  'Ã´', 'Ã¶', 'Ã²',
					  'Ã¯', 'Ã®', 'Ã¬',
					  'Ã¹', 'Ã»', 'Ã¼',
					  'Ã¿',
					  'ç');
	$car_OK = array('e', 'e', 'e', 'e',
					'a', 'a', 'a', 'a', 'a',
					'o', 'o', 'o',
					'i', 'i', 'i',
					'u', 'u', 'u',
					'y',
					'c');
	$r = str_replace($car_mauv, $car_OK, $str);
	
	$r = preg_replace('#[^a-zA-Z0-9_.-]#', $default, $r);
	$r = preg_replace('#'. preg_quote($default) .'+#', $default, $r);
	
	return $r;
}
?>