<?php
/**
 *
 *
 *
 */
class PPMail {
	
	//==============================
	//	Variables
	//==============================
	
	/**
	 *	@var  $_to  string  mail adresse of destinataire
	 */
	private $_to;
	
	/**
	 *	@var  $_exp  string  mail adresse of expeditor
	 */
	private $_exp;
	
	/**
	 *	@var  $_content  string  content of message
	 */
	private $_content;
	
	
	//==============================
	//	Entrés utilisateur
	//==============================
	
	/**
	 *	@arg  $mailTo  string  define mail adresse of destinataire
	 */
	public function setTo($mailTo) {
		$this->_to = $mailTo;
	}
	
	/**
	 *	@arg  $name  string  define name of expeditor
	 *	@arg  $mail  string  define adresse mail of expeditor
	 */
	public function setExp($name, $mail) {
		$this->_exp['name'] = $name;
		$this->_exp['mail'] = $mail;
	}
	
	/**
	 *	@arg  $content  string  define the content of message
	 */
	public function setContent($content) {
		$this->_content = $content;
	}

	/**
	 *	@arg  $subject  string  define the subjet of message
	 */
	public function setSubject($subject) {
		$this->_subject = $subject;
	}


	
	//==============================
	//	Vérification
	//==============================
	
	/**
	 *
	 */
	public function is_mail($mail) {
		return preg_match("#^[a-z0-9._-]+@[a-z0-9._-]{2,}\.[a-z]{2,4}$#", $mail);
	}

	//==============================
	//	Envoie du mail
	//==============================

	/**
	 *
	 */
	private function send() {
		//	Create the boundary
		$boundary = "-----=".md5(rand());
		 
		//	Create header de l'e-mail
		$header = 'From: "' . $this->_exp['name'] . '"<' . $this->_exp['mail'] . '>\n';
		$header = 'Reply-to: "' . $this->_exp['name'] . '"<' . $this->_exp['mail'] . '>\n';
		$header.= "MIME-Version: 1.0\n";
		$header.= "Content-Type: multipart/alternative;\n boundary=\"$boundary\"\n";
		 
		//	Create message
		$message = "\n--".$boundary."\n";
		$message.="Content-Type: text/html; charset=\"ISO-8859-1\"\n";
		$message.="Content-Transfer-Encoding: 8bit\n";
		$message.= $this->_content ."\n";

		$message.= "\n--". $boundary ."--\n";
		$message.= "\n--". $boundary ."--\n";
		 
		//	Send e-mail
		mail($this->_to, $this->_subject, $message, $header);
	}
}
?>