<?php
/**
 *	POWER + SITE   -  [CLASSE] sSQL PDO
 *	Auteur : Power + Techonologie  <http://power-plus-technologie.fr>
 *	Licence : Creative Commons BY-NC
 */

class sSQL {

	protected $queryObject;
	protected $instance;
	private static $_instance;

	public function __construct($auto = true) {
		if($auto) {
			return $this->connexionAuto();
		}
	}


	private function connexionAuto() {
		if(!isset(self::$_instance)) {
			try {
				self::$_instance = new PDO('mysql:host='. BDD_SRV .';dbname='. BDD_NOM, BDD_USR, BDD_MDP);
			}
			catch(Exception $e) {
				exit ('Erreur lors de la connexion : '.$e->getMessage());
			}
		}
		$this->instance = self::$_instance;
	}

	public function connexion($serveurSQL, $identifiantSQL, $mdp, $bdd) {
		$return = true;
		try {
			$this->instance = new PDO('mysql:host='. $serveurSQL .';dbname='. $bdd, $identifiantSQL, $mdp);
		}
		catch(Exception $e) {
			$return = false;
		}
		return $return;
	}


	public function query($query) {
		$query = preg_replace('#T\{(.+)\}#iUs', TABLE_PRE."$1", $query);
		
		if($req = $this->instance->query($query)) {
			$this->queryObject = $req;
			$this->nbReqs++;
			return $this;
		}
		else {
			return false;
		}
	}

	public function lastInsertId() {
		return $this->instance->lastInsertId();
	}
	
	
	public function fetch($reqNum = NULL) {
		return $this->queryObject->fetch();
	}


	public function numRows($reqNum = NULL) {
		return $this->queryObject->rowcount();
	}
	
	public function quote($str, $type = 'string') {
		return $this->instance->quote($str);
	}
	
	public function prepare($query, array $values) {
		try {
			$q = $this->instance->prepare($query);
			$q->execute($values);
		} 
		catch(PDOException $e) {
			return false;
		}
	}
}
?>