<?php
class Tag {
	public $tagsList = array();
	public $_sql;
	
	public function __construct() {
		$this->_sql = new sSQL();
		$req = $this->_sql->query("SELECT * FROM `T{core_tags}`");
		while($data = $req->fetch()) {
			$this->tagsList[$data['ID']] = $data['nom'];
		}
	}
	
	
	public function getHTML($tags, $url = false) {
		$retour = '';
		if(!empty($tags)) {
			$nb_tags = substr_count($tags, ';');
			foreach(explode(';', $tags) as $n => $tag) {
				if($url)
					$retour .= '<a href="'. $url . $tag . '" rel="tag">' . $this->getPublicName($tag) . '</a>' . (($n < $nb_tags) ? ', ' : '.');
				else
					$retour .= $this->getPublicName($tag) . (($n < $nb_tags) ? ';' : '');
			}
		}
		else
			$retour .= (($url) ? 'aucun' : '');
		return $retour;
	}
	
	
	public function getPublicName($brutName) {
		return $this->tagsList[$brutName];
	}
	
	
	public function listTags() {
		$listTags = false;
		$req = $this->_sql->query("SELECT * FROM `T{core_tags}` ORDER BY `nom`");
		while($tags = $req->fetch()) {
			if(!empty($tags[0]))
				$listTags[] = $tags;
		}
		return $listTags;
	}

	/**
	 *	Remet au propre la base de données des tags en selectionnant toutes les news
	 *	publiées, en analysant les tags et les insère dans la base de données
	 */
	public function diffTag($iTags) {
		
		$tags = array();
		foreach(explode(';', $iTags) as $sTag) {
			$tags[normaliser($sTag)] = $sTag;
		}
		
		if(count($iTags) > 0) {
			$req = $this->_sql->query("SELECT * FROM `T{core_tags}`");
			while($tag = $req->fetch()) {
				if(array_key_exists($tag['ID'], $tags))
					unset($tags[$tag['ID']]);
			}
			
			foreach($tags as $sTag) {
				$this->_sql->query("INSERT INTO `T{core_tags}` VALUES(". $this->_sql->quote(normaliser($sTag)) .",". $this->_sql->quote($sTag) .")");
			}
		}
	}
}
?>