<?php
/**
 *	POWER + SITE   -  Core -> [CLASSE] Theme
 *	Auteur : Power + Techonologie  <http://power-plus-technologie.fr>
 *	Licence : Creative Commons BY-NC
 */

class Theme {
	
	private $_buffer;
	private $_theme;
	private $menu = array();
	

	public function Theme($theme) {
		$this->theme['chemin'] = $theme;
		
		$xml = simplexml_load_file(ROOT . $this->theme['chemin'] . '/theme.xml');
		
		foreach($xml->menus->menu as $mXML) {
			$idMenu = (string) $mXML->attributes()->id;
            
			$infosMenu = array(
						'id' => $idMenu,
						'type' => (string) $mXML->attributes()->type,
						'titreTpl' => (string) $mXML->titreTpl,
						'itemTpl' => (string) $mXML->itemTpl,
						'groupeBox' => (string) $mXML->groupeBox
					);
			
			if($infosMenu['type'] == 'admin') {
				$this->menu[$idMenu] = $this->_getHTMLAdminMenu($infosMenu);
			}
			elseif($infosMenu['type'] == 'rich' || $infosMenu['type'] == 'links') {
				$this->menu[$idMenu] = $this->_getHTMLRichMenu($infosMenu, $infosMenu['type']);
			}
		}
	}
	
	
	private function _getHTMLRichMenu($masterMenu, $type) {
		$menuContent = '';

		$oMenu = new PPMenu($masterMenu['id']);
		if($m = $oMenu->listItems()) {
			foreach($m as $menu) {
				if($menu['type'] == 'h1' || $menu['type'] == 'link') {
					$o = $menu['text'];
					
					//	Traitement des URL
					if(array_key_exists('url', $menu) && !empty($menu['url']))
						$o = '<a href="'. $menu['url']  .'">' . $o . '</a>';
					
					//	Traitement des titres
					if($menu['type'] == 'h1' && $type == 'rich')
						$o = '<h3>'. $o .'</h3>';
					
					elseif($menu['type'] == 'link')
						$o = '<ul><li>'. $o .'</li></ul>';
					
					if(!($type == 'links' && $menu['type'] == 'h1'))
						$menuContent .= $o;
				}
				
				//	Tratement des gadgets
				elseif($menu['type'] == "gadget" && $type == 'rich') {
					ob_start();
					if(!empty($menu['options']))
						$gadget_options = $menu['options'];
					include 'gadgets/' . $menu['dossier'] . '/gadget.php';
					$content_gad = ob_get_contents();
					unset($gadget_options);
					ob_clean();
					$menuContent .= $content_gad; 
				}
			}
			return str_replace('</ul><ul>', '', $menuContent);
		}
		else
			return '';
	}


	private function _getHTMLAdminMenu($infosMenu) {
		$menuContent = '';

		if($infosMenu['id'] == 'admin') {
			$menuContent = '<ul>';
			$menuURL = ROOT . '/core/conf/menu-admin.xml';
			$xml = simplexml_load_file($menuURL);
			foreach($xml->lien as $lien) {
				$items[] = array('importance' => (string) $lien->attributes()->importance, 'texte' => (string) $lien, 'url' => (string) $lien->attributes()->url);
			}
			
			$items = sortByKey($items, 'importance', 'asc');
			
			foreach($items as $lien) {
				$menuContent .= '<li><a href="'. $lien['url'] .'">'. $lien['texte'] .'</a></li>';
			}
			$menuContent .= '</ul>';
		}
		return $menuContent;
	}


	private function _getFlux() {
		$html = '';
		if(is_array($this->flux)) {
			foreach($this->flux as $infos) {
				if($infos['type'] == 'RSS') {
					$html .= '<link rel="alternate" type="application/rss+xml" title="'. $infos['titre'] .'" href="'. $infos['url'] .'" />';
				}
				elseif($infos['type'] == 'Atom') {
					$html .= '<link rel = "alternate" type = "application/atom+xml" title = "'. $infos['titre'] .'" href = "'. $infos['url'] .'"/>';
				}
			}
		}
		return $html;
	}


	public function send() {
		
		ob_start();
			include ROOT . $this->theme['chemin'] . '/tpl.php';
		$tpl = ob_get_contents();
		ob_clean();
		
		$css = '<link href="'. ROOT . $this->theme['chemin'] .'/pps.css" rel="stylesheet" type="text/css" />';
		$titre = '<title>' . $this->site['nom'] . ' - '. $this->site['titre'] . '</title>';
		$head = $this->_getFlux() . $css . $titre;
		$this->_buffer = preg_replace('`<head(.*)>(.*)</head>`isU','<head$1>$2'. $head .'</head>', $tpl);
 
		echo $this->_buffer;
	}
}
?>