<?php
/**
 *	POWER + SITE  -  Core -> Setup
 *	Auteur : Power + Technologie <http://power-plus-technologie.fr>
 *	Licence : Creative Commons BY-NC
 */

function is_connect($serveurSQL, $identifiantSQL, $mdp, $bdd) {
	$sql = new sSQL(false);
	return $sql->connexion($serveurSQL, $identifiantSQL, $mdp, $bdd);
}

function echo_html($str) {
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">',
		'<html xmlns="http://www.w3.org/1999/xhtml">',
		'<head>',
		'<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />',
		'<title>Installation de Power + Site</title>',
		'</head>',
		'<body>',
		$str,
		'</body>',
		'</html>';
}

if(file_exists('setup.conf.php') || isset($bdd, $admin)) {
	define('ROOT', '');
	define('VERSION_SETUP', file_get_contents('core/conf/version.txt'));
	
	if(!isset($bdd, $admin)) {
		require 'setup.conf.php';
	}
	require 'core/lib/secure.fx.php';
	require 'core/lib/core.fx.php';
	require 'core/lib/selecteur_sql.php';

	if(is_connect($bdd['serv'], $bdd['user'], $bdd['mdp'], $bdd['bdd'])) {
		//	Création de setting.php
		$configPHP = "<?php
		define('BDD_NOM', '". $bdd['bdd'] ."');
		define('BDD_SRV', '". $bdd['serv'] ."');
		define('BDD_USR', '". $bdd['user'] ."');
		define('BDD_MDP', '". $bdd['mdp'] ."');
		define('TABLE_PRE', '". $bdd['pre'] ."');
		?".">";
		
		file_put_contents('core/conf/setting.php', $configPHP);
		
		//	Connexion à la BDD
		require 'core/conf/setting.php';
		$sql = new sSQL();
		
		//	Création des tables
		include 'setup/get_sql_base.php';
		
		//	Copie des fichiers
		copy('setup/menu-admin.xml', 'core/conf/menu-admin.xml');
		copy('setup/menu-site.xml', 'core/conf/menu-site.xml');
		
		
		//	Ecriture des options
		$siteNom = $sql->quote($site['nom']);
		$siteSlogan = $sql->quote($site['slogan']);
		
		if(empty($site['url']))
			$siteURL = $sql->quote('http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']));
		else
			$siteURL = $sql->quote($site['url']);
		
		$req = "INSERT INTO `T{core_options}` (`nom` ,`valeur`) 
				VALUES ('site_nom', $siteNom),
				('site_url', $siteURL), 
				('site_slogan', $siteSlogan)";
		$sql->query($req);
		
		//	Suppression des fichiers d'installation
		unlink('setup.php');
		unlink('setup.ui.php');
		foreach(scandir('setup') as $file) {
			if($file != '.' && $file != '..')
				unlink('setup/' . $file);
		}
		
		rmdir('setup');
		
		header('Location: index.php');
	}
	else
		echo_html('Erreur de connexion à la base de données.');
}
else
	echo_html('Veuillez suivre les étapes décrites dans "setup.conf.sample.php" OU utiliser le formulaire <a href="setup.ui.php">setup.ui.php</a>.');
?>